VBA code for changing reference when opening a . SLDPRT

Hello

In a . SLDPRT (n°1), I use the combine function with an external reference (file n°(2) . SLDPRT as well),  in order to obtain the desired final shape directly by shrinkage.

File n°1 being a standard database and file n°2 having a variable geometry.

For a new variant, I open file n°1 by clicking on the tab "References... " and so I replace file n°2 with a file n°3 with new geometry.

I currently have a macro that allows me to select which 3D files to open, but is there a way to open this type of file automatically while giving the user a hand so that they can select the replacement part?

Thank you in advance for your help.

 

 

Hello

Can you put some example files so that we can help you?

Kind regards.

2 Likes

Hello Yves.T,

I can't attach the original parts for confidentiality reasons, but I have put 3 simple pieces as examples to explain the principle.

Piece 1 built with combination of Piece 2 or 3 depending on the choice of reference to the opening.

Thank you.


changement_ref.rar

For me the only way to replace a part insert in a part is to go through replacing the references before opening this file.

Hello

In the attached macro, the first file to select is the parent file and the second is the file to subtract. Pay attention to the names of the bodies in your files, it should work with your example files.

Kind regards


combiner.swp

Hello d.roger and thank you for the time spent trying to find a solution.

I just tried the macro, it opens the parent file, but during the second selection, the file to be subtracted opens in the tree without replacing the one already in place!

A small clarification concerning the names of the bodies to be subtracted, they will be different each time. (P1, P2, P3....)

Kind regards.

Hello

Version 2 of the macro ....

Kind regards


combiner.swp
1 Like

@d.Roger,

Great, the Macro version 2 works with the parts given as an example.

On the other hand, if I run it with another file with a different tree structure (see attached image), the macro executes without performing the combine function.

In this example, part M2031 has been replaced by part M2032, but not removed from the main body.

Could this be due to the fact that there are other build operations after the combine function? (here a revolution and a holiday)

Thank you.

 


arborescence_inf_.gif

Yes, it comes from the fact that the type of machining done on the parts is different, it comes from the lines:

boolstatus = Part.Extension.SelectByID2("Revolution1", "SOLIDBODY", 0, 0, 0, False, 1, Nothing, 0)
boolstatus = Part.Extension.SelectByID2("<" & NewName & ">-<Revolution1>", "SOLIDBODY", 0, 0, 0, True, 2, Nothing, 0)

Or the names of the selected bodies are Revolution1, to correct this you have to analyze the creation tree and retrieve the names of the bodies, I don't have time to do it at the moment but if you want to do it you should be able to use the following lines:

Set Feature = Part.FirstFeature
Dim Piece As String
While Not Feature Is Nothing
 FeatureName = Feature.Name
 If Feature.GetTypeName2 = "Stock" Then
    Piece = FeatureName
 End If
 Set Feature = Feature.GetNextFeature()
Wend

to do so.

Kind regards

1 Like

OK!

 I'll try to look at this, but I'm not at all comfortable with VBA codes! 

There is a high probability that I will ask for your help again to fix the macro as soon as you have availability!

Thank you again and have a good weekend!

 

 

Hello everyone!

I tried to adapt D.Roger's macro, but the "combine" function still doesn't run:

'Search in the feature manager of the part to be subtracted (it took me a while to understand where the name "Stock" came from: press CTRL G in the execution window to bring up the list of names and types of each feature!)

Set Feature = Part.FirstFeature
        Dim Piece1 As String
        While Not Feature Is Nothing
        FeatureName = Feature.Name
         If Feature.GetTypeName2 = "Stock" Then
         Piece1 = FeatureName
         End If
        Set Feature = Feature.GetNextFeature()
        Wend

 

Main Body Selection
    boolstatus = Part.Extension.SelectByID2("Removed mat.-Extru.3", "SOLIDBODY", 0, 0, 0, False, 1, Nothing, 0) 

'Selection of the share to be subtracted
    boolstatus = Part.Extension.SelectByID2(Piece1, "BODYFEATURE", 0, 0, 0, True, 2, Nothing, 0) 

'Combining bodies
    Set myFeature = Part.FeatureManager.InsertCombineFeature(15902, Nothing, Nothing)

The 2 pieces are well selected, but the last line which should perform the subtraction of the bodies remains inactive.?!

I should be able to select the volume bodies of the part to be subtracted but without taking the one of the main body, I tried with "SolidBodyFolder"... but it doesn't work either!

I'm sure there's not much, but my knowledge of VBA isn't enough to solve this sticking point.

If anyone can guide me on a possible solution?!

Thank you.


lyncoa_20171010.gif

... In fact that's right, the "combine" line of code works with:

boolstatus = Part.Extension.SelectByID2("<M2032_REN306VF_sortie-mold>-<REN305-02A.1\\Main body>", "SOLIDBODY", 0, 0, 0, True, 2, Nothing, 0)
    boolstatus = Part.Extension.SelectByID2("<M2032_REN306VF_sortie-mold>-<REN305_01A.1\\Main body>", "SOLIDBODY", 0, 0, 0, True, 2, Nothing, 0)
    boolstatus = Part.Extension.SelectByID2("<M2032_REN306VF_sortie-mold>-<REN305_CC.1\\Main body>", "SOLIDBODY", 0, 0, 0, True, 2, Nothing, 0)

    Set myFeature = Part.FeatureManager.InsertCombineFeature(15902, Nothing, Nothing)

... but the names of the bodies will change with each new part(Ex <M2031_REN305VF_sortie-mold>-<REN304_CC.1\\Main body>)!

So I have to find a way to select the volume of the new inserted part.

Can anyone help me solve this problem?

Thank you in advance.


lyncoa_20171011.gif

Hello

You can use a loop on the features that fetches a "SOLIDBODYFOLDER" feature.

Once found, assign it to a bodyfolder variable using feature. GetSpecificFeature()

All that's left to do is loop over the solids and select them with Body.Select(). It seems to me that it is possible to add a flag with this method. If not, use the selection manager to make the selections.

Hello Yves.T,

I had tried with a loop (with D.Roger's code) which was supposed to recover the volume of my piece1 (see below)...

... but doesn't work either! I'm going to keep scratching, but I must be missing an order!

Do you have an example for "feature. GetSpecificFeature()" and sorry for my beginner question, but what do you mean by "add a flag"?

Set Feature = Part.FirstFeature
        Dim Piece1 As String
        While Not Feature Is Nothing
        FeatureName = Feature.Name
         If Feature.GetTypeName2 = "Stock" Then
         Piece1 = FeatureName
         End If
        Set Feature = Feature.GetNextFeature()
        Wend
       
    Main Body Selection
    boolstatus = Part.Extension.SelectByID2("Removed mat.-Extru.3", "SOLIDBODY", 0, 0, 0, False, 1, Nothing, 0)
    'Selection of the share to be subtracted
    boolstatus = Part.Extension.SelectByID2("<Piece1>-<Volumes>", "BDYFOLDER", 0, 0, 0, True, 2, Nothing, 0)

    Set myFeature = Part.FeatureManager.InsertCombineFeature(15902, Nothing, Nothing)

Thank you.

I'll give you an example for a loop that recovers bodies in VBA.

The loop you put as an example retrieves the name of a feature if it's of the "Stock" type.

I haven't checked but I'm not sure if "Stock" is one of the values returned by GetTypeName2. . This is to be checked in the help.

boolstatus = Part.Extension.SelectByID2("<Piece1>-<Volumes>", "BODYFOLDER", 0, 0, 0, True, 2, Nothing, 0)

In this statement, you ask it to select an object named <Piece1>-<Bulking Bodies> of type BODYFOLDER. he is not likely to find it:) put BODY instead.

In the Select functions (SelectById, SelectById2,...) there is a parameter that is used to put an indicator on a selection, that's a flag.

In some Solidworks functions, it is possible to select several objects (Example: in a boss, you select the contour sketches and then the guide curves) the flag allows Solidworks to place the selected objects in the right "box". The selections with flag 1 will be the contours, flag 2, the guide curves.

Hello

It's quickly cobbled together but try with the attached macro to see if it suits you.

Kind regards


combiner.swp
1 Like

You will find attached a commented macro example

The only conditions for it to work:

Naming the main body as "MainBody"

Have + of a volume body


feature.swp
1 Like

Hello and sorry for the late return, a lot of topics in progress...!

@d.Roger,

I would like to know how to "tinker" with the VBA as you do, but I think I still have a long way to go!

the macro works great (in single), but when I call it by another macro, I had to remove 'Explicit Option', add a small piece of code to see the Solidworks application...

'Allows you to view the SolidWorks application.
swApp.Visible = True
If swApp Is Nothing Then
Set swApp = CreateObject("SldWorks.Application")
swApp.Visible = True
End If

... and in the end it bugs on...

"Set Feature = Part.FeatureManager.InsertCombineFeature(swBodyOperationType_e.SWBODYCUT, Nothing, Nothing)"

... and doesn't seem to follow up on the "Sub SelectBodies(swApp As SldWorks.SldWorks... "

Communication problem then?!?

@Yves.T,

To rename the main bodies to "MainBody" it should be possible to do this, on the other hand there can be only one pafrois volume body. In any case thank you for the comments in the macro, it really helps with understanding , I'll see if I can adapt!

Hello

First of all, thank you for the compliment at the beginning but in vba I'm just "tinkering", it's a programming language that Yves.T masters much more than me who follows more C# oriented.

For the removal of the explicit option, either. For rows that display Solidworks, OK if the macro is launched through another macro. For the Sub SelectBodies(.....), it has already been called at the time of the bug so no problem at that level and for the bug on the line "Set Feature = Part.FeatureManager.InsertCombineFeature(swBodyOperationType_e.SWBODYCUT, Nothing, Nothing)", as Yves.T rightly indicated in his macro ("but above all, we use the mark to get the good ones") you can replace the line:

"Set Feature = Part.FeatureManager.InsertCombineFeature(swBodyOperationType_e.SWBODYCUT, Nothing, Nothing)"

by  the lines:

Sun SelMgr As SelectionMgr
Set SelMgr = Part.SelectionManager
Set Feature = Part.FeatureManager.InsertCombineFeature(swBodyOperationType_e.SWBODYCUT, SelMgr.GetSelectedObject6(1, 1), SelMgr.GetSelectedObject6(1, 2))

Let's see if it works the way you want it to.

Kind regards

Hello d.roger,

I just replaced the lines of code and it blocks on:

"Set Feature = Part.FeatureManager.InsertCombineFeature(swBodyOperationType_e.SWBODYCUT, SelMgr.GetSelectedObject6(1, 1), SelMgr.GetSelectedObject6(1, 2))"

Error 424: Required Object

Kind regards